
;
; VESA Library V1.00
; Mainly written for Turbo PASCAL
; Copyright (c) 1994 Huseyin Nakturk
;

COPY_PUT        equ 0
XOR_PUT         equ 1
AND_PUT         equ 2
TRANS_PUT       equ 3 ; transparent for 0
FALSE           equ 0
TRUE            equ 1

bptr            equ <byte ptr>
wptr            equ <word ptr>
dptr            equ <dword ptr>

                p286
                locals
                assume cs:code

                extrn status_al            : Byte
                extrn status_ah            : Byte
                extrn vmodeattr            : word
                extrn vwinaattr            : byte
                extrn vwinbattr            : byte
                extrn vgranularity         : word
                extrn vwindowsize          : word
                extrn vwinaseg             : word
                extrn vwinbseg             : word
                extrn vbytesperscan        : word
                extrn vscrwidth            : word
                extrn vscrheight           : word
                extrn vcharwidth           : byte
                extrn vcharheight          : byte
                extrn vnummemplanes        : byte
                extrn vbitsperpixel        : byte
                extrn vnumofbanks          : byte
                extrn vmemmodel            : byte
                extrn vbanksize            : byte
                extrn vnumimgpages         : byte

code            segment para public 'code'
                push cs
                pop ds
                lea dx,text
                mov ah,9
                int 21h
                mov ax,04c01h
                int 21h
text:           db 10,13
                db 'VESA library v1.00 for Turbo PASCAL',13,10
                db '(c) 1994 Huseyin NAKTURK '
                db 'compiled at ',??time,' ',??date,13,10
                db 'Object file.Not for stand alone use.'
                db 13,10
                db '$'

vesastruc       label word
modeattr        dw 0 ; mode attributes
winaattr        db 0 ; window A attributes
winbattr        db 0 ; window B attributes
granularity     dw 0 ; window granularity in K
windowsize      dw 0 ; window size in K
winaseg         dw 0 ; window A start segment
winbseg         dw 0 ; window B start segment
farwindow       dd 0 ; far window pointer
bytesperscan    dw 0 ; bytes per scan line
scrwidth        dw 0 ; screen width in pixels
scrheight       dw 0 ; screen height in pixels
charwidth       db 0 ; char width in pixels
charheight      db 0 ; char height in pixels
Nummemplanes    db 0 ; number of memory planes
bitsperpixel    db 0 ; bits per pixel
numofbanks      db 0 ; number of banks
memmodel        db 0 ; memory model
banksize        db 0 ; size of bank in K
numimgpages     db 0 ; number of image pages
garbage         db 256-1dh dup(0)

; below ones for internal use
mousemask       db 0
lineskip        dw 0
oldbussy        db 0
currentbank     dw 0
bankend         dw 0 ; Bank length
scx             dw 0 ; leftmost pixel
sdx             dw 0 ; starting scan line
charseg1        dw 0 ; bios char table segment (0 < x < 128)
charofs1        dw 0 ; bios char table offset
charseg2        dw 0 ; bios char table segment (127 < x < 256)
charofs2        dw 0 ; bios char table offset
vmousex         dw 0 ; mouse x
vmousey         dw 0 ; mouse y
mtype           db 0 ; mouse put type
iambussy        db 0
oldmousex       dw 0 ; old mouse x
oldmousey       dw 0 ; old mouse y
mouseactive     db 0
vputmode        db COPY_PUT ; put mode
leftofs         dw 0
leftseg         dw 0
rightofs        dw 0
rightseg        dw 0
scrolling       db 0 ; are we scrolling (VESA already wait for vertical trace)
mousew          dw 11 ; mouse width
mouseh          dw 18 ; mouse height
fillval         db 0
fillcolor       db 0
clipx1          dw 0
clipy1          dw 0
clipx2          dw 0
clipy2          dw 0
clip            db 0
pageno          db 0
pagelen         dw 0
actstart        dw 0
visstart        dw 0
charw           dw 8
charh           dw 8

mousespr        label word
                db 001,001,000,000,000,000,000,000,000,000,000
                db 001,031,001,000,000,000,000,000,000,000,000
                db 001,031,031,001,000,000,000,000,000,000,000
                db 001,031,031,031,001,000,000,000,000,000,000
                db 001,031,031,031,031,001,000,000,000,000,000
                db 001,031,031,031,031,031,001,000,000,000,000
                db 001,031,031,031,031,031,031,001,000,000,000
                db 001,031,031,031,031,031,031,031,001,000,000
                db 001,031,031,031,031,031,031,031,031,001,000
                db 001,031,031,031,031,031,031,031,031,031,001
                db 001,031,031,031,031,031,031,001,001,001,001
                db 001,031,031,031,031,031,031,001,000,000,000
                db 001,031,031,001,001,031,031,001,000,000,000
                db 001,031,001,000,000,001,031,031,001,000,000
                db 001,001,000,000,000,001,031,031,001,000,000
                db 001,000,000,000,000,000,001,031,031,001,000
                db 000,000,000,000,000,000,001,031,031,001,000
                db 000,000,000,000,000,000,000,001,001,000,000

MouseUnder      label word
                db 11*18 dup(0)
prefix          macro
                push bp
                mov bp,sp
                push ds
                push es
                push si
                push di
                endm

postfix         macro
                pop di
                pop si
                pop es
                pop ds
                pop bp
                endm
                include ports.inc
                include _mode.inc
                include _mouse.inc
                include _point.inc
                include _line.inc
                include _scroll.inc
                include _text.inc
                include _fill.inc
                include _image.inc
                include _palette.inc
                include _clip.inc
                include _vsync.inc
                include _page.inc
                include _font.inc
code            ends
                end
